package com.tuoheng.system.controller;


import com.tuoheng.common.annotation.Log;
import com.tuoheng.common.enums.LogType;
import com.tuoheng.common.utils.JsonResult;
import com.tuoheng.system.entity.Dept;
import com.tuoheng.system.query.DeptQuery;
import com.tuoheng.system.service.IDeptService;
import com.tuoheng.system.service.ITenantService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.tuoheng.common.common.BaseController;

/**
 * <p>
 * 部门表 前端控制器
 * </p>
 *
 * @author 拓恒
 * @since 2020-11-03
 */
@RestController
@RequestMapping("/dept")
public class DeptController extends BaseController {

    @Autowired
    private IDeptService deptService;
    @Autowired
    private ITenantService iTenantService;
    /**
     * 获取部门列表
     *
     * @param deptQuery 查询条件
     * @return
     */
    //@RequiresPermissions("sys:dept:index")
    @GetMapping("/index")
    public JsonResult index(DeptQuery deptQuery) {
        return deptService.getList(deptQuery);
    }

    /**
     * 添加部门
     *
     * @param entity 实体对象
     * @return
     */
    @Log(title = "部门管理", logType = LogType.INSERT)
    //@RequiresPermissions("sys:dept:add")
    @PostMapping("/add")
    public JsonResult add(@RequestBody Dept entity) {
        entity.setTenantId(iTenantService.getCurrentTenantId());
        return deptService.edit(entity);
    }

    /**
     * 编辑部门
     *
     * @param entity 实体对象
     * @return
     */
    @Log(title = "部门管理", logType = LogType.UPDATE)
    //@RequiresPermissions("sys:dept:edit")
    @PutMapping("/edit")
    public JsonResult edit(@RequestBody Dept entity) {
        entity.setTenantId(iTenantService.getCurrentTenantId());
        return deptService.edit(entity);
    }

    /**
     * 删除部门
     *
     * @param deptId 部门ID
     * @return
     */
    @Log(title = "部门管理", logType = LogType.DELETE)
    //@RequiresPermissions("sys:dept:delete")
    @DeleteMapping("/delete/{deptId}")
    public JsonResult delete(@PathVariable("deptId") Integer deptId) {
        return deptService.deleteById(deptId);
    }

    /**
     * 获取部门列表
     *
     * @return
     */
    @GetMapping("/getDeptList")
    public JsonResult getDeptList() {
        return deptService.getDeptList();
    }

}
